Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ABL/ablmod.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ABL/ablmod.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ABL/ablmod.F90	(revision 13630)
@@ -529,6 +529,11 @@
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       !
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ablmod',  u_abl(:,:,:,nt_a      ), 'T', -1._wp,  v_abl(:,:,:,nt_a)      , 'T', -1._wp                            )
+      CALL lbc_lnk_nc_multi( 'ablmod', tq_abl(:,:,:,nt_a,jp_ta), 'T', 1._wp , tq_abl(:,:,:,nt_a,jp_qa), 'T',  1._wp , kfillmode = jpfillnothing )   ! ++++ this should not be needed...
+#else
       CALL lbc_lnk_multi( 'ablmod',  u_abl(:,:,:,nt_a      ), 'T', -1._wp,  v_abl(:,:,:,nt_a)      , 'T', -1._wp                            )
       CALL lbc_lnk_multi( 'ablmod', tq_abl(:,:,:,nt_a,jp_ta), 'T', 1._wp , tq_abl(:,:,:,nt_a,jp_qa), 'T',  1._wp , kfillmode = jpfillnothing )   ! ++++ this should not be needed...
+#endif
       !
 #if defined key_iomput
@@ -594,5 +599,9 @@
       END_2D
       !
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ablmod', zwnd_i(:,:) , 'T', -1.0_wp, zwnd_j(:,:) , 'T', -1.0_wp )
+#else
       CALL lbc_lnk_multi( 'ablmod', zwnd_i(:,:) , 'T', -1.0_wp, zwnd_j(:,:) , 'T', -1.0_wp )
+#endif
       !
       ! ... scalar wind ( = | U10m - U_oce | ) at T-point (masked)
@@ -619,5 +628,9 @@
       END_2D
       !
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ablmod', ptaui(:,:), 'U', -1.0_wp, ptauj(:,:), 'V', -1.0_wp )
+#else
       CALL lbc_lnk_multi( 'ablmod', ptaui(:,:), 'U', -1.0_wp, ptauj(:,:), 'V', -1.0_wp )
+#endif
 
       CALL iom_put( "taum_oce", ptaum )
@@ -639,5 +652,9 @@
             &                      * ( 0.5_wp * ( v_abl(ji,jj+1,2,nt_a) + v_abl(ji,jj,2,nt_a) ) - pssv_ice(ji,jj) )
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ablmod', ptaui_ice, 'U', -1.0_wp, ptauj_ice, 'V', -1.0_wp )
+#else
       CALL lbc_lnk_multi( 'ablmod', ptaui_ice, 'U', -1.0_wp, ptauj_ice, 'V', -1.0_wp )
+#endif
       !
       IF(sn_cfctl%l_prtctl)   CALL prt_ctl( tab2d_1=ptaui_ice  , clinfo1=' abl_stp: putaui : '   &
@@ -658,5 +675,9 @@
             &         * ( zztmp2 - pssv_ice(ji,jj) )
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ablmod', ptaui_ice, 'U', -1.0_wp, ptauj_ice,'V', -1.0_wp )
+#else
       CALL lbc_lnk_multi( 'ablmod', ptaui_ice, 'U', -1.0_wp, ptauj_ice,'V', -1.0_wp )
+#endif
       !
       IF(sn_cfctl%l_prtctl) THEN
@@ -865,7 +886,15 @@
       ! Optional : could add pblh smoothing if pblh is noisy horizontally ...
       IF(ln_smth_pblh) THEN
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'ablmod', pblh, 'T', 1.0_wp) !, kfillmode = jpfillnothing)
+#else
          CALL lbc_lnk( 'ablmod', pblh, 'T', 1.0_wp) !, kfillmode = jpfillnothing)
+#endif
          CALL smooth_pblh( pblh, msk_abl )
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'ablmod', pblh, 'T', 1.0_wp) !, kfillmode = jpfillnothing)
+#else
          CALL lbc_lnk( 'ablmod', pblh, 'T', 1.0_wp) !, kfillmode = jpfillnothing)
+#endif
       ENDIF
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icecor.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icecor.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icecor.F90	(revision 13630)
@@ -113,5 +113,9 @@
             ENDIF
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icecor', u_ice, 'U', -1.0_wp, v_ice, 'V', -1.0_wp )
+#else
          CALL lbc_lnk_multi( 'icecor', u_ice, 'U', -1.0_wp, v_ice, 'V', -1.0_wp )
+#endif
       ENDIF
 
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn.F90	(revision 13630)
@@ -161,5 +161,9 @@
                   &             + e1v(ji,jj) * v_ice(ji,jj) - e1v(ji,jj-1) * v_ice(ji,jj-1) ) * r1_e1e2t(ji,jj)
             END_2D
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'icedyn', zdivu_i, 'T', 1.0_wp )
+#else
             CALL lbc_lnk( 'icedyn', zdivu_i, 'T', 1.0_wp )
+#endif
             ! output
             CALL iom_put( 'icediv' , zdivu_i )
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_adv_pra.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_adv_pra.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_adv_pra.F90	(revision 13630)
@@ -158,6 +158,11 @@
          END_3D
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_pra', zei_max, 'T', 1. )
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_pra', zes_max, 'T', 1. )
+#else
       CALL lbc_lnk( 'icedyn_adv_pra', zei_max, 'T', 1. )
       CALL lbc_lnk( 'icedyn_adv_pra', zes_max, 'T', 1. )
+#endif
       !
       !
@@ -311,5 +316,9 @@
                &                          - ( zudy(ji,jj) - zudy(ji-1,jj) + zvdx(ji,jj) - zvdx(ji,jj-1) ) * r1_e1e2t(ji,jj) * zdt
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icedyn_adv_pra', pato_i, 'T',  1.0_wp )
+#else
          CALL lbc_lnk( 'icedyn_adv_pra', pato_i, 'T',  1.0_wp )
+#endif
          !
          ! --- Ensure non-negative fields --- !
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_adv_umx.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_adv_umx.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_adv_umx.F90	(revision 13630)
@@ -162,6 +162,11 @@
          END_3D
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_pra', zei_max, 'T', 1. )
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_pra', zes_max, 'T', 1. )
+#else
       CALL lbc_lnk( 'icedyn_adv_pra', zei_max, 'T', 1. )
       CALL lbc_lnk( 'icedyn_adv_pra', zes_max, 'T', 1. )
+#endif
       !
       !
@@ -384,5 +389,9 @@
                &                          - ( zudy(ji,jj) - zudy(ji-1,jj) + zvdx(ji,jj) - zvdx(ji,jj-1) ) * r1_e1e2t(ji,jj) * zdt
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', pato_i, 'T',  1.0_wp )
+#else
          CALL lbc_lnk( 'icedyn_adv_umx', pato_i, 'T',  1.0_wp )
+#endif
          !
          !
@@ -518,5 +527,9 @@
             END_2D
          END DO
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zt_ups, 'T',  1.0_wp )
+#else
          CALL lbc_lnk( 'icedyn_adv_umx', zt_ups, 'T',  1.0_wp )
+#endif
          !
          IF    ( np_limiter == 1 ) THEN
@@ -601,5 +614,9 @@
                END_2D
             END DO
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#else
             CALL lbc_lnk( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#endif
             !
             DO jl = 1, jpl              !-- flux in y-direction
@@ -625,5 +642,9 @@
                END_2D
             END DO
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#else
             CALL lbc_lnk( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#endif
             !
             DO jl = 1, jpl              !-- flux in x-direction
@@ -647,5 +668,9 @@
          END_2D
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', pt_ups, 'T', 1.0_wp )
+#else
       CALL lbc_lnk( 'icedyn_adv_umx', pt_ups, 'T', 1.0_wp )
+#endif
 
    END SUBROUTINE upstream
@@ -709,5 +734,9 @@
                END_2D
             END DO
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#else
             CALL lbc_lnk( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#endif
 
             DO jl = 1, jpl              !-- flux in y-direction
@@ -735,5 +764,9 @@
                END_2D
             END DO
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#else
             CALL lbc_lnk( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#endif
             !
             DO jl = 1, jpl              !-- flux in x-direction
@@ -793,5 +826,9 @@
             END_2D
          END DO
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#else
          CALL lbc_lnk( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#endif
          !
          !                                                        !--  ultimate interpolation of pt at v-point  --!
@@ -820,5 +857,9 @@
             END_2D
          END DO
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#else
          CALL lbc_lnk( 'icedyn_adv_umx', zpt, 'T', 1.0_wp )
+#endif
          !
          !                                                        !--  ultimate interpolation of pt at u-point  --!
@@ -873,5 +914,9 @@
          END DO
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', ztu2, 'T', 1.0_wp )
+#else
       CALL lbc_lnk( 'icedyn_adv_umx', ztu2, 'T', 1.0_wp )
+#endif
       !
       !                                                     !--  BiLaplacian in i-direction  --!
@@ -887,5 +932,9 @@
          END DO
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', ztu4, 'T', 1.0_wp )
+#else
       CALL lbc_lnk( 'icedyn_adv_umx', ztu4, 'T', 1.0_wp )
+#endif
       !
       !
@@ -1013,5 +1062,9 @@
          END_2D
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', ztv2, 'T', 1.0_wp )
+#else
       CALL lbc_lnk( 'icedyn_adv_umx', ztv2, 'T', 1.0_wp )
+#endif
       !
       !                                                     !--  BiLaplacian in j-direction  --!
@@ -1024,5 +1077,9 @@
          END_2D
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', ztv4, 'T', 1.0_wp )
+#else
       CALL lbc_lnk( 'icedyn_adv_umx', ztv4, 'T', 1.0_wp )
+#endif
       !
       !
@@ -1163,5 +1220,9 @@
             END_2D
          END DO
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zti_ups, 'T', 1.0_wp, ztj_ups, 'T', 1.0_wp )
+#else
          CALL lbc_lnk_multi( 'icedyn_adv_umx', zti_ups, 'T', 1.0_wp, ztj_ups, 'T', 1.0_wp )
+#endif
 
          DO jl = 1, jpl
@@ -1185,5 +1246,9 @@
             END_2D
          END DO
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', pfu_ho, 'U', -1.0_wp, pfv_ho, 'V', -1.0_wp )   ! lateral boundary cond.
+#else
          CALL lbc_lnk_multi( 'icedyn_adv_umx', pfu_ho, 'U', -1.0_wp, pfv_ho, 'V', -1.0_wp )   ! lateral boundary cond.
+#endif
 
       ENDIF
@@ -1242,5 +1307,9 @@
          END_2D
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zbetup, 'T', 1.0_wp, zbetdo, 'T', 1.0_wp )   ! lateral boundary cond. (unchanged sign)
+#else
       CALL lbc_lnk_multi( 'icedyn_adv_umx', zbetup, 'T', 1.0_wp, zbetdo, 'T', 1.0_wp )   ! lateral boundary cond. (unchanged sign)
+#endif
 
       
@@ -1297,5 +1366,9 @@
          END_2D
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zslpx, 'U', -1.0_wp)   ! lateral boundary cond.
+#else
       CALL lbc_lnk( 'icedyn_adv_umx', zslpx, 'U', -1.0_wp)   ! lateral boundary cond.
+#endif
       
       DO jl = 1, jpl
@@ -1361,5 +1434,9 @@
          END_2D
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', pfu_ho, 'U', -1.0_wp)   ! lateral boundary cond.
+#else
       CALL lbc_lnk( 'icedyn_adv_umx', pfu_ho, 'U', -1.0_wp)   ! lateral boundary cond.
+#endif
       !
    END SUBROUTINE limiter_x
@@ -1388,5 +1465,9 @@
          END_2D
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', zslpy, 'V', -1.0_wp)   ! lateral boundary cond.
+#else
       CALL lbc_lnk( 'icedyn_adv_umx', zslpy, 'V', -1.0_wp)   ! lateral boundary cond.
+#endif
 
       DO jl = 1, jpl
@@ -1453,5 +1534,9 @@
          END_2D
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icedyn_adv_umx', pfv_ho, 'V', -1.0_wp)   ! lateral boundary cond.
+#else
       CALL lbc_lnk( 'icedyn_adv_umx', pfv_ho, 'V', -1.0_wp)   ! lateral boundary cond.
+#endif
       !
    END SUBROUTINE limiter_y
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_rdgrft.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_rdgrft.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_rdgrft.F90	(revision 13630)
@@ -801,5 +801,9 @@
             strength(ji,jj) = zworka(ji,jj)
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icedyn_rdgrft', strength, 'T', 1.0_wp )
+#else
          CALL lbc_lnk( 'icedyn_rdgrft', strength, 'T', 1.0_wp )
+#endif
          !
       CASE( 2 )               !--- Temporal smoothing
@@ -820,5 +824,9 @@
             ENDIF
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icedyn_rdgrft', strength, 'T', 1.0_wp )
+#else
          CALL lbc_lnk( 'icedyn_rdgrft', strength, 'T', 1.0_wp )
+#endif
          !
       END SELECT
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_rhg_evp.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_rhg_evp.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icedyn_rhg_evp.F90	(revision 13630)
@@ -322,9 +322,5 @@
 
       END_2D
-#if defined key_mpi3
-      CALL lbc_lnk_nc_multi( 'icedyn_rhg_evp', zmf, 'T', 1.0_wp, zdt_m, 'T', 1.0_wp )
-#else
       CALL lbc_lnk_multi( 'icedyn_rhg_evp', zmf, 'T', 1.0_wp, zdt_m, 'T', 1.0_wp )
-#endif
       !
       !                                  !== Landfast ice parameterization ==!
@@ -408,6 +404,9 @@
 
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icedyn_rhg_evp', zdelta, 'T', 1.0_wp )
+#else
          CALL lbc_lnk( 'icedyn_rhg_evp', zdelta, 'T', 1.0_wp )
-
+#endif
          ! P/delta at T points
          DO_2D( 1, 1, 1, 1 )
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icesbc.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icesbc.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icesbc.F90	(revision 13630)
@@ -86,5 +86,9 @@
             vtau_ice(ji,jj) = vtau_ice(ji,jj) * xcplmask(ji,jj,0) + zvtau_ice(ji,jj) * ( 1. - xcplmask(ji,jj,0) )
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icesbc', utau_ice, 'U', -1.0_wp, vtau_ice, 'V', -1.0_wp )
+#else
          CALL lbc_lnk_multi( 'icesbc', utau_ice, 'U', -1.0_wp, vtau_ice, 'V', -1.0_wp )
+#endif
       ENDIF
       !
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icethd.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icethd.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icethd.F90	(revision 13630)
@@ -132,5 +132,9 @@
          END_2D
       ENDIF
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'icethd', zfric, 'T',  1.0_wp )
+#else
       CALL lbc_lnk( 'icethd', zfric, 'T',  1.0_wp )
+#endif
       !
       !--------------------------------------------------------------------!
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icethd_do.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icethd_do.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icethd_do.F90	(revision 13630)
@@ -191,5 +191,9 @@
          END_2D
          ! 
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icethd_do', zvrel, 'T', 1.0_wp, ht_i_new, 'T', 1.0_wp  )
+#else
          CALL lbc_lnk_multi( 'icethd_do', zvrel, 'T', 1.0_wp, ht_i_new, 'T', 1.0_wp  )
+#endif
 
       ENDIF
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/iceupdate.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/iceupdate.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/iceupdate.F90	(revision 13630)
@@ -342,5 +342,9 @@
             tmod_io(ji,jj) = zrhoco * SQRT( zmodt )          ! rhoco * |U_ice-U_oce| at T-point
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'iceupdate', taum, 'T', 1.0_wp, tmod_io, 'T', 1.0_wp )
+#else
          CALL lbc_lnk_multi( 'iceupdate', taum, 'T', 1.0_wp, tmod_io, 'T', 1.0_wp )
+#endif
          !
          utau_oce(:,:) = utau(:,:)                    !* save the air-ocean stresses at ice time-step
@@ -371,5 +375,9 @@
          vtau(ji,jj) = ( 1._wp - zat_v ) * vtau_oce(ji,jj) + zat_v * zvtau_ice
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'iceupdate', utau, 'U', -1.0_wp, vtau, 'V', -1.0_wp )   ! lateral boundary condition
+#else
       CALL lbc_lnk_multi( 'iceupdate', utau, 'U', -1.0_wp, vtau, 'V', -1.0_wp )   ! lateral boundary condition
+#endif
       !
       IF( ln_timing )   CALL timing_stop('ice_update_tau')
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icewri.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icewri.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/ICE/icewri.F90	(revision 13630)
@@ -137,5 +137,9 @@
             z2d(ji,jj) = 0.5_wp * SQRT( z2da * z2da + z2db * z2db )
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'icewri', z2d, 'T', 1.0_wp )
+#else
          CALL lbc_lnk( 'icewri', z2d, 'T', 1.0_wp )
+#endif
          CALL iom_put( 'icevel', z2d )
 
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/NST/agrif_oce_sponge.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/NST/agrif_oce_sponge.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/NST/agrif_oce_sponge.F90	(revision 13630)
@@ -290,14 +290,26 @@
       
       IF( .NOT. spongedoneT .AND. .NOT. spongedoneU ) THEN
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'agrif_Sponge', fspu, 'U', 1._wp, fspv, 'V', 1._wp, fspt, 'T', 1._wp, fspf, 'F', 1._wp )
+#else
          CALL lbc_lnk_multi( 'agrif_Sponge', fspu, 'U', 1._wp, fspv, 'V', 1._wp, fspt, 'T', 1._wp, fspf, 'F', 1._wp )
+#endif
          spongedoneT = .TRUE.
          spongedoneU = .TRUE.
       ENDIF
       IF( .NOT. spongedoneT ) THEN
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'agrif_Sponge', fspu, 'U', 1._wp, fspv, 'V', 1._wp )
+#else
          CALL lbc_lnk_multi( 'agrif_Sponge', fspu, 'U', 1._wp, fspv, 'V', 1._wp )
+#endif
          spongedoneT = .TRUE.
       ENDIF
       IF( .NOT. spongedoneT .AND. .NOT. spongedoneU ) THEN
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'agrif_Sponge', fspt, 'T', 1._wp, fspf, 'F', 1._wp )
+#else
          CALL lbc_lnk_multi( 'agrif_Sponge', fspt, 'T', 1._wp, fspf, 'F', 1._wp )
+#endif
          spongedoneU = .TRUE.
       ENDIF
@@ -323,5 +335,9 @@
       ztabrampu(:,:) = REAL( mbku_parent(:,:), wp )
       ztabrampv(:,:) = REAL( mbkv_parent(:,:), wp )
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'Agrif_Sponge', ztabramp, 'T', 1._wp, ztabrampu, 'U', 1._wp, ztabrampv, 'V', 1._wp )
+#else
       CALL lbc_lnk_multi( 'Agrif_Sponge', ztabramp, 'T', 1._wp, ztabrampu, 'U', 1._wp, ztabrampv, 'V', 1._wp )
+#endif
       mbkt_parent(:,:) = NINT( ztabramp (:,:) )
       mbku_parent(:,:) = NINT( ztabrampu(:,:) )
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/NST/agrif_user.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/NST/agrif_user.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/NST/agrif_user.F90	(revision 13630)
@@ -99,6 +99,11 @@
 
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'agrif_istate', uu(:,:,:  ,Kbb), 'U', -1.0_wp , vv(:,:,:,Kbb), 'V', -1.0_wp )
+      CALL lbc_lnk_nc_multi(       'agrif_istate', ts(:,:,:,:,Kbb), 'T',  1.0_wp )
+#else
       CALL lbc_lnk_multi( 'agrif_istate', uu(:,:,:  ,Kbb), 'U', -1.0_wp , vv(:,:,:,Kbb), 'V', -1.0_wp )
       CALL lbc_lnk(       'agrif_istate', ts(:,:,:,:,Kbb), 'T',  1.0_wp )
+#endif
 
    END SUBROUTINE Agrif_Istate
@@ -273,19 +278,35 @@
       ENDIF
       !
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'Agrif_Init_Domain', hu0_parent, 'U', 1.0_wp, hv0_parent, 'V', 1.0_wp )
+#else
       CALL lbc_lnk_multi( 'Agrif_Init_Domain', hu0_parent, 'U', 1.0_wp, hv0_parent, 'V', 1.0_wp )
+#endif
       DO_2D( 0, 0, 0, 0 )
          zk(ji,jj) = REAL( mbku_parent(ji,jj), wp )
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'Agrif_InitValues_cont', zk, 'U', 1.0_wp )
+#else
       CALL lbc_lnk( 'Agrif_InitValues_cont', zk, 'U', 1.0_wp )
+#endif
       mbku_parent(:,:) = MAX( NINT( zk(:,:) ), 1 )
       DO_2D( 0, 0, 0, 0 )
          zk(ji,jj) = REAL( mbkv_parent(ji,jj), wp )
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'Agrif_InitValues_cont', zk, 'V', 1.0_wp )
+#else
       CALL lbc_lnk( 'Agrif_InitValues_cont', zk, 'V', 1.0_wp )
+#endif
       mbkv_parent(:,:) = MAX( NINT( zk(:,:) ), 1 )   
 
       IF ( ln_init_chfrpar ) THEN 
          CALL Agrif_Init_Variable(sshini_id, procname=agrif_initssh)
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'Agrif_Init_Domain', ssh(:,:,Kbb), 'T', 1. )
+#else
          CALL lbc_lnk( 'Agrif_Init_Domain', ssh(:,:,Kbb), 'T', 1. )
+#endif
          DO jk = 1, jpk
                e3t(:,:,jk,Kbb) =  e3t_0(:,:,jk) * ( ht_0(:,:) + ssh(:,:,Kbb)  ) &
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/ASM/asminc.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/ASM/asminc.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/ASM/asminc.F90	(revision 13630)
@@ -421,5 +421,9 @@
                      &            / e3t(ji,jj,jk,Kmm)
                END_2D
+#if defined key_mpi3
+               CALL lbc_lnk_nc_multi( 'asminc', zhdiv, 'T', 1.0_wp )   ! lateral boundary cond. (no sign change)
+#else
                CALL lbc_lnk( 'asminc', zhdiv, 'T', 1.0_wp )   ! lateral boundary cond. (no sign change)
+#endif
                !
                DO_2D( 0, 0, 0, 0 )
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/BDY/bdydyn2d.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/BDY/bdydyn2d.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/BDY/bdydyn2d.F90	(revision 13630)
@@ -102,8 +102,16 @@
          END DO
          IF( ANY(llsend2) .OR. ANY(llrecv2) ) THEN   ! if need to send/recv in at least one direction
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'bdydyn2d', pua2d, 'U', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend2, lrecv=llrecv2 )
+#else
             CALL lbc_lnk( 'bdydyn2d', pua2d, 'U', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend2, lrecv=llrecv2 )
+#endif
          END IF
          IF( ANY(llsend3) .OR. ANY(llrecv3) ) THEN   ! if need to send/recv in at least one direction
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'bdydyn2d', pva2d, 'V', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend3, lrecv=llrecv3 )
+#else
             CALL lbc_lnk( 'bdydyn2d', pva2d, 'V', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend3, lrecv=llrecv3 )
+#endif
          END IF
          !
@@ -324,5 +332,9 @@
          IF( nn_hls > 1 .AND. ir == 1 ) CYCLE   ! at least 2 halos will be corrected -> no need to correct rim 1 before rim 0
          IF( ANY(llsend1) .OR. ANY(llrecv1) ) THEN   ! if need to send/recv in at least one direction
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'bdydyn2d', zssh(:,:,1), 'T',  1.0_wp, kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
+#else
             CALL lbc_lnk( 'bdydyn2d', zssh(:,:,1), 'T',  1.0_wp, kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
+#endif
          END IF
       END DO
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/BDY/bdydyn3d.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/BDY/bdydyn3d.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/BDY/bdydyn3d.F90	(revision 13630)
@@ -99,8 +99,16 @@
          !
          IF( ANY(llsend2) .OR. ANY(llrecv2) ) THEN   ! if need to send/recv in at least one direction
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'bdydyn2d', puu(:,:,:,Kaa), 'U', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend2, lrecv=llrecv2 )
+#else
             CALL lbc_lnk( 'bdydyn2d', puu(:,:,:,Kaa), 'U', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend2, lrecv=llrecv2 )
+#endif
          END IF
          IF( ANY(llsend3) .OR. ANY(llrecv3) ) THEN   ! if need to send/recv in at least one direction
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'bdydyn2d', pvv(:,:,:,Kaa), 'V', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend3, lrecv=llrecv3 )
+#else
             CALL lbc_lnk( 'bdydyn2d', pvv(:,:,:,Kaa), 'V', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend3, lrecv=llrecv3 )
+#endif
          END IF
       END DO   ! ir
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/BDY/bdyice.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/BDY/bdyice.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/BDY/bdyice.F90	(revision 13630)
@@ -94,4 +94,13 @@
          IF( ANY(llsend1) .OR. ANY(llrecv1) ) THEN   ! if need to send/recv in at least one direction
             ! exchange 3d arrays
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi('bdyice', a_i , 'T', 1._wp, h_i , 'T', 1._wp, h_s , 'T', 1._wp, oa_i, 'T', 1._wp                   &
+               &                       , s_i , 'T', 1._wp, t_su, 'T', 1._wp, v_i , 'T', 1._wp, v_s , 'T', 1._wp, sv_i, 'T', 1._wp &
+               &                       , a_ip, 'T', 1._wp, v_ip, 'T', 1._wp, v_il, 'T', 1._wp                                     &
+               &                       , kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
+            ! exchange 4d arrays :   third dimension = 1   and then   third dimension = jpk
+            CALL lbc_lnk_nc_multi('bdyice', t_s , 'T', 1._wp, e_s , 'T', 1._wp, kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
+            CALL lbc_lnk_nc_multi('bdyice', t_i , 'T', 1._wp, e_i , 'T', 1._wp, kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
+#else
             CALL lbc_lnk_multi('bdyice', a_i , 'T', 1._wp, h_i , 'T', 1._wp, h_s , 'T', 1._wp, oa_i, 'T', 1._wp                   &
                &                       , s_i , 'T', 1._wp, t_su, 'T', 1._wp, v_i , 'T', 1._wp, v_s , 'T', 1._wp, sv_i, 'T', 1._wp &
@@ -101,4 +110,5 @@
             CALL lbc_lnk_multi('bdyice', t_s , 'T', 1._wp, e_s , 'T', 1._wp, kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
             CALL lbc_lnk_multi('bdyice', t_i , 'T', 1._wp, e_i , 'T', 1._wp, kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
+#endif
          END IF
       END DO   ! ir
@@ -438,5 +448,9 @@
             END DO
             IF( ANY(llsend2) .OR. ANY(llrecv2) ) THEN   ! if need to send/recv in at least one direction
+#if defined key_mpi3
+               CALL lbc_lnk_nc_multi( 'bdyice', u_ice, 'U', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend2, lrecv=llrecv2 )
+#else
                CALL lbc_lnk( 'bdyice', u_ice, 'U', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend2, lrecv=llrecv2 )
+#endif
             END IF
          CASE ( 'V' )
@@ -452,5 +466,9 @@
             END DO
             IF( ANY(llsend3) .OR. ANY(llrecv3) ) THEN   ! if need to send/recv in at least one direction
+#if defined key_mpi3
+               CALL lbc_lnk_nc_multi( 'bdyice', v_ice, 'V', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend3, lrecv=llrecv3 )
+#else
                CALL lbc_lnk( 'bdyice', v_ice, 'V', -1.0_wp, kfillmode=jpfillnothing ,lsend=llsend3, lrecv=llrecv3 )
+#endif
             END IF
          END SELECT
